# Path on the control node

BBX_INSTALL_PATH=/mnt/beetleboxci
CONTROL_NODE_FQDN=work1-virtualbox.local

# File storage
BBX_DEPLOY_NODE="work1-virtualbox"
BBX_DEPLOY_NODE_IP=10.0.2.15

# For multi-node clusters or machines that are part of a domain, we recommend setting the NFS_SERVER to 
# the same value as the NFS_SERVER_FQDN. 
# For single node clusters, you may set NFS_SERVER to the same as the NFS_SERVER_IP if the IP is static, 
# otherwise use the NFS_SERVER_FQDN or just the use the NFS_SERVER_NAME (host name)
# This parameter is used by BeetleboxCI containers to access the NFS
# The NFS_SERVER may or may not be part of the Kubernetes cluster

NFS_SERVER=work1-virtualbox.local

# On a single-node installation where the machine is not part of a domain, set this to [NFS_SERVER_NAME].local
NFS_SERVER_FQDN=work1-virtualbox.local

NFS_SERVER_NAME=work1-virtualbox
NFS_SERVER_IP=10.0.2.15

NFS_SOURCE_PATH=/mnt/beetleboxci/nfs

# The BeetleboxCI installation uses the REGISTRY_URL to issue https requests to the registry. 
# On multinode clusters are machines that are part of a domain, we recommend setting REGISTRY_URL to 
# the same value as the REGISTRY_FQDN
# For single node clusters, you may set REGISTRY_URL to the same as the REGISTRY_IP if the IP is static, 
# otherwise use the REGISTRY_NODE_NAME (host name)
# The registry runs as a container on the cluster

REGISTRY_URL=10.0.2.15

# On a single-node installation where the machine is not part of a domain, set this to [REGISTRY_NODE_NAME].local 
REGISTRY_FQDN=work1-virtualbox.local

REGISTRY_NODE_NAME=work1-virtualbox
REGISTRY_IP=10.0.2.15

# The path on the REGISTRY NODE where the image data will be stored
REGISTRY_NODE_PATH=/mnt/beetleboxci

# The path on the CONTROL NODE where the registry certificates from the registry node are stored. 
# The certificates need to be manually copied to every node that needs to acccess the registry
# We recommend keeping file paths the same across nodes for consistency
# For single node clusters, this value will be the same as the REGISTRY_NODE_PATH
REGISTRY_CERT_PATH=/mnt/beetleboxci 

