# ci_webapp


This branch contains shell scripts to automatically deploy, build and run the brief_automation repo on your local machine, if you have a valid deploy key

## Installation Guide

### AWS Deployment

### Local Deployment

#### Installing Packages
To deploy locally, ensure that **Python 3.7.5** is installed and your virtual environment is active:

```C
source ~/eb-virt/bin/activate
```

Install all the pip3 packages from the **requirements.txt** package

For local deployments the following environmental setting must be launched

```C
export WORKFLOW_STATE="AWSCLOUD"
```

#### Setting Up File System
Links to setting up file stystem can be found here:
https://docs.aws.amazon.com/efs/latest/ug/mount-fs-auto-mount-onreboot.html

For dev version use EFS access point, btu once deployed onn beanstalk, configuration files are used

#### Setting Up Databases
Beetlebox CI relies on both Postgresql and Redis (for RQ). A Postgresqls server must be running locally with the following:

```C
'NAME': 'ci_webapp_db',
'USER': 'ci_user',
'PASSWORD': 'TPW9SSvAsrRfn7YMzrVGZxrEpYyyTeC7yEagkVGuUyg7yU8sfR',
'HOST': 'localhost',
'PORT': '5432',
```

A Redis server must also be running

### Usage Guide
The callback function in the python program calls the webhook_trigger.sh script, which in turn calls the webhook_automation script. This runs a series of scripts to clone, build and run the repo. The public key must be added to the repo and you must have the private key on your machine

To generate a key (no need to use a password for the key if it's on your machine):

1) ssh-keygen -t ed25519 -C "your-email@beetlebox.org"

2) Add the public key to the github repo you want to deploy

3) Test cloning the repo: git clone git@github.com:beetleboxorg/repo_name.git


You may have to carry out an additional step of adding the private key to the ssh-agent, but I didn't have to do that. 

https://docs.github.com/en/free-pro-team@latest/developers/overview/managing-deploy-keys#deploy-keys




The AWS_SECRET_ACCESS_KEY should be set as an environment variable, and the one used for testing has been changed, so any key that was committed to this repo is no longer valid. 


