document.addEventListener('DOMContentLoaded', async () => {

  const cancelYes = document.querySelector('#cancel-yes');
  
  cancelYes.addEventListener('click', async (e) => {
    e.preventDefault();

    const {subscription} = await fetch('cancel-subscription/', {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'X-CSRFToken': getCookie('csrftoken'),
      },
      credentials: 'same-origin',
      body: JSON.stringify({
        subscriptionId: ''
      }),
    })
      .then((response) => response.json())
      
      .then(data => {
        if(data.error) {
          console.error('Error:', data.error.message);
        }     
        else{
          
          setTimeout(() => {
            window.location.href = user_profile;
          }, 3 * 1000);
          
        }
      })         
    
  });

});


function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}