let stripe, clientSecret;

fetch(change_plan_get_config, {method: 'GET',})
  .then((response) => response.json())
  .then((data) => {
    
    pricesDiv.innerHTML = '';
    if(!data.prices) {
      pricesDiv.innerHTML = `
        <h3>No prices found</h3>
      `
    }

    data.prices.forEach((price) => {
      pricesDiv.innerHTML += `
        <div>

          <button class="btn btn-primary" onclick="updateSubscription('${price.id}')">Confirm</button>
        </div>
      `;
    });
  })
  .catch((error) => {
    console.error('Error:', error);
  });

fetch(change_plan_get_key, {
  method: 'POST',
  headers: {
    'Content-Type': 'application/json',
    'X-CSRFToken': getCookie('csrftoken'),
  },
  credentials: 'same-origin',
})
  .then((resp) => resp.json())
  .then((data) => {
    if(data.error) {
      console.error('Error:', data.error.message);
    }    
    else {
      stripe = Stripe(data.publishableKey)
    }
    
  });  






const pricesDiv = document.querySelector('#price-list');

var slider = new Slider("#ex13");
slider.on("change", function(sliderValue) {
	document.getElementById("ex13SliderVal").textContent = sliderValue.newValue;
});
slider.on("change", function(sliderValue) {
	document.getElementById("ex13SliderCost").textContent = Number(11*sliderValue.newValue/25000).toFixed(2);
});




function updateSubscription(priceId) {
  return fetch(update_subscription, {
    method: 'post',
    headers: {
      'Content-type': 'application/json',
      'X-CSRFToken': getCookie('csrftoken'),
    },
    credentials: 'same-origin',
    body: JSON.stringify({
      priceId: priceId,
      quantity: slider.getValue()
      
    }),
  })
    .then(response => {
      return response.json();
    })
    .then(data => {
      
      if(data.error) {
        alert(data.error.message); 
        console.error('Error:', data.error.message);
      }     
      else{
        clientSecret = data.clientSecret
        
        // if (data.status === 'requires_action') {
        // if (data.status === 'requires_payment_method') {

        if (data.status === 'succeeded') {
          // the payment won't succeed immediately when the stripe radar settings are set to always force 3D secure authentication
          window.location.href = user_profile;    
          
        }          
        else if (data.status === 'requires_confirmation') {
          // this happens when payment behaviour of the subscription is set to default_incomplete (the default payment behaviour is allow_incomplete)

          stripe.confirmCardPayment(clientSecret).then(function(result) {
            if (result.error) {
              // alert(result.error.message); // this creates a pop up message
              // TODO - this could possibly redirect to a page where the user can choose one of the other existing payment methods or enter a new payment method.
              alert("Payment failed. Please enter a new payment method or go back and set a different default payment method from your wallet before attempting to update your subscription.")
              const params = new URLSearchParams(window.location.search);
              params.append('subscriptionId', data.subscriptionId);
              window.location.href = update_pm + '?' + params.toString();   
            } else {     
              
              // Redirect to the account page.
              setTimeout(() => {
                window.location.href = user_profile;
              }, 3 * 1000);                   
              
            } 
          });       

        }        
        else if (data.status === 'requires_action') {
          // 3D secure authentication requested
          stripe.confirmCardPayment(clientSecret).then(function(result) {
            if (result.error) {
              
              alert("Payment failed. Please enter a new payment method or go back and set a different default payment method from your wallet before attempting to update your subscription.")
              const params = new URLSearchParams(window.location.search);
              params.append('subscriptionId', data.subscriptionId);

              window.location.href = update_pm + '?' + params.toString();   
            } else {     
              
              // Redirect to the account page.
              setTimeout(() => {
                window.location.href = user_profile;
              }, 3 * 1000);                   
              
            } 
          });    
        } 
        else if (data.status === 'requires_payment_method') {
          // Authentication failed, prompt the customer to enter another payment method
          
          alert("Payment failed. Please enter a new payment method or go back and set a different default payment method from your wallet before attempting to update your subscription.")
          const params = new URLSearchParams(window.location.search);
          params.append('subscriptionId', data.subscriptionId);

          window.location.href = update_pm + '?' + params.toString();   
          

        }
        else if (data.status === 'processing') {
          // for cards, processing happens almost immediately but for other types of payment methods, it may take longer
          alert("Payment request received.")
          window.location.href = user_profile;    

        }        
       

          
        
      }
    })
    .catch((error) => {
      console.error('Error:', error);
    });
}

function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}