document.addEventListener('DOMContentLoaded', async () => {
  // Fetch the list of subscriptions for this customer.
  const {pms} = await fetch('pms/').then((r) => r.json());

  const pmsDiv = document.querySelector('#pms');
  pmsDiv.innerHTML = pms.data.map((pm) => {
    let last4 = pm.card?.last4 || '';
    
    text = `
      <hr>

      <p>
        Type: ${pm.card.brand}
      </p>      
    
      <p> Card ending: ${last4} </p>
      
      <p> Expires: ${pm.card.exp_month}/${pm.card.exp_year} </p>
      
      <button type="button" class="btn btn-outline-primary btn-sm" data-toggle="modal" data-target="#pm_remove" data-pmid="${pm.id}">Remove payment method </button>    
      <button type="button" class="btn btn-outline-primary btn-sm" data-toggle="modal" data-target="#pm_confirm_default" data-pmid="${pm.id}">Set as default payment method</button>   
      
      <br>


    `;
    
    
    return text;
    
  }).join('<br />');
  
  
});




function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}
