document.addEventListener('DOMContentLoaded', async () => {

  // When the cancel button is clicked, send an AJAX request
  // to our server to cancel the subscription.
  const removeBtn = document.querySelector('#remove-btn');
  
  removeBtn.addEventListener('click', async (e) => {
    e.preventDefault();

    var pmid = document.getElementById('pmid_in_remove').value;

    const {result} = await fetch(remove_pm, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json',
        'X-CSRFToken': getCookie('csrftoken'),
      },
      credentials: 'same-origin',
      body: JSON.stringify({
        pmid: pmid
      }),
    })
      .then((response) => response.json())
      .then(data => {
        if(data.error) {
          alert(data.error.message);
        }     
        else{
          
          setTimeout(() => {
            window.location.href = user_profile;
          }, 3 * 1000);
          
        }
      })  
      
  });

});



function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}