fetch(register_get_config, {method: 'GET',})
  .then((response) => response.json())
  .then((data) => {
    pricesDiv.innerHTML = '';
    if(!data.prices) {
      pricesDiv.innerHTML = `
        <h3>No prices found</h3>
      `
    }

    data.prices.forEach((price) => {
      pricesDiv.innerHTML += `
        <div>

          <button class="btn btn-primary"  onclick="createSubscription('${price.id}')">Checkout</button>
        </div>
      `;
    });
  })
  .catch((error) => {
    console.error('Error:', error);
  });


const pricesDiv = document.querySelector('#price-list');

var slider = new Slider("#ex13");
slider.on("change", function(sliderValue) {
	document.getElementById("ex13SliderVal").textContent = sliderValue.newValue;
});
slider.on("change", function(sliderValue) {
	document.getElementById("ex13SliderCost").textContent = Number(11*sliderValue.newValue/25000).toFixed(2);
});


const createSubscription = (priceId) => {
  

  return fetch(create_subscription, {
    method: 'POST',
    headers: {
      'Content-Type': 'application/json',
      'X-CSRFToken': getCookie('csrftoken'),
    },
    credentials: 'same-origin',
    body: JSON.stringify({
      priceId: priceId,
      quantity: slider.getValue()
    }),
  })
    .then((response) => response.json())
    .then((data) => {
      
      if(data.error) {
        alert(data.error.message); 
        
        console.error('Error:', data.error);

      }     
      else{
        const params = new URLSearchParams(window.location.search);
        params.append('subscriptionId', data.subscriptionId);
        window.location.href = subscribe + '?'+ params.toString();        
      }
      
    })
    .catch((error) => {
      console.error('Error:', error);
    });
}


function getCookie(name) {
    let cookieValue = null;
    if (document.cookie && document.cookie !== '') {
        const cookies = document.cookie.split(';');
        for (let i = 0; i < cookies.length; i++) {
            const cookie = cookies[i].trim();
            // Does this cookie string begin with the name we want?
            if (cookie.substring(0, name.length + 1) === (name + '=')) {
                cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                break;
            }
        }
    }
    return cookieValue;
}

