$(function () {
    $('[data-bs-toggle="tooltip"]').tooltip()
})   

document.addEventListener('DOMContentLoaded', async () => {
    
    // Fetch the list of subscriptions for this customer.
    const {workflows, branches} = await fetch(get_workflows).then((r) => r.json());
    
    var current= new Date();
  
    var workflowsDiv = document.querySelector('#wf_list');
    workflowsDiv.innerHTML = ''
  
  
    var branchdata = branches.map((branch) => {
      
    branch_text = ''
    var branch_start=`
    
    <div class="card mb-4">
        <div class="card-header"  style="color:black">
        
            <div class="row align-items-center " >
                <div class="col-auto me-auto">
                
                    <svg width="20px" height="20px" aria-hidden="true" focusable="false" data-prefix="fas" data-icon="code-branch" class="svg-inline--fa fa-code-branch fa-w-12" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512"><path fill="currentColor" d="M384 144c0-44.2-35.8-80-80-80s-80 35.8-80 80c0 36.4 24.3 67.1 57.5 76.8-.6 16.1-4.2 28.5-11 36.9-15.4 19.2-49.3 22.4-85.2 25.7-28.2 2.6-57.4 5.4-81.3 16.9v-144c32.5-10.2 56-40.5 56-76.3 0-44.2-35.8-80-80-80S0 35.8 0 80c0 35.8 23.5 66.1 56 76.3v199.3C23.5 365.9 0 396.2 0 432c0 44.2 35.8 80 80 80s80-35.8 80-80c0-34-21.2-63.1-51.2-74.6 3.1-5.2 7.8-9.8 14.9-13.4 16.2-8.2 40.4-10.4 66.1-12.8 42.2-3.9 90-8.4 118.2-43.4 14-17.4 21.1-39.8 21.6-67.9 31.6-10.8 54.4-40.7 54.4-75.9zM80 64c8.8 0 16 7.2 16 16s-7.2 16-16 16-16-7.2-16-16 7.2-16 16-16zm0 384c-8.8 0-16-7.2-16-16s7.2-16 16-16 16 7.2 16 16-7.2 16-16 16zm224-320c8.8 0 16 7.2 16 16s-7.2 16-16 16-16-7.2-16-16 7.2-16 16-16z"></path></svg>
                    &nbsp; 
                    ${branch.name_of_branch}  
                    
                </div>
                <div class="col-auto">
                
                    <button  type="button" class="btn" data-workflowid="${branch.uid} " data-bs-toggle="modal" data-bs-target="#run_workflow" data-bs-toggle="tooltip" data-bs-placement="top" title="Run branch">
                        <svg width="30px" height="30px" aria-hidden="true" focusable="false" data-prefix="far" data-icon="play-circle" class="svg-inline--fa fa-play-circle fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M371.7 238l-176-107c-15.8-8.8-35.7 2.5-35.7 21v208c0 18.4 19.8 29.8 35.7 21l176-101c16.4-9.1 16.4-32.8 0-42zM504 256C504 119 393 8 256 8S8 119 8 256s111 248 248 248 248-111 248-248zm-448 0c0-110.5 89.5-200 200-200s200 89.5 200 200-89.5 200-200 200S56 366.5 56 256z"></path></svg>        
                        
                    </button>  
        
                </div>
            </div>        
        
        </div>
        <div class="card-body">
            <div class="table-responsive-lg">
      
                <table class="table  dataTable"  id="${branch.name_of_branch}" role="grid" style="width: 100%;">
                    <thead>
                    <tr>
                    
                        <th> Workflow Name </th>
                        <th> Status </th>
                        <th> Commit </th>
                        <th> Trigger </th>
                        
                        <th > Last Run </th>
                        
                        <th> Run Time </th>
                        <th> Log </th>
                        
                        <th> Actions </th>
                    </tr>
                    </thead>   
                    <tbody>  
                  `

    var branch_end =`
                    </tbody>
                </table>  
            </div>
        </div>
    </div>
    
      `     
      
    var prev_workflow = ''
    var dark_background  = false
    
    
    workflow_text = ''
    
    workflows.forEach((workflow) => {
        
        if (workflow.git_branch === branch.name_of_branch){
            
            workflow.human_readable_runtime = format_runtime(workflow.runtime)

            if (prev_workflow === workflow.workflow_name){
                
                // workflow.filtered_name = workflow.workflow_name
                // // workflow.filtered_name = '' // hide the name if it is the same as the name above
                workflow.dark_background = dark_background
                
            }
            else {
                // workflow.filtered_name = workflow.workflow_name
                prev_workflow = workflow.workflow_name
                
                dark_background = !dark_background
                workflow.dark_background = dark_background
            }  
            
                
            if (workflow.dark_background){
                workflow_text += `
                    <tr style="background-color:#EFEFEF" >
                `;
            } 
            else {
                workflow_text += `
                    <tr >
                `;                
                
            }
            
            workflow_text += `
                <td><a href="${ workflow.url_path }"> ${ workflow.workflow_name }</a></td>
            `;
            
            if (workflow.status === 'FA'){
            workflow_text += `   
                <td><div class="badge rounded-pill bg-danger">Failed</div></td>
            `;
            }
            else if (workflow.status === 'ID'){
            workflow_text += ` 
                <td><div class="badge rounded-pill bg-primary">Idle</div></td>
            `;
            }
            else if (workflow.status === 'IN'){
            workflow_text += ` 
                <td><div class="badge rounded-pill bg-primary">Initialised</div></td>
            `;
            }            
            else if (workflow.status === 'SC'){
            workflow_text += ` 
                <td><div class="badge rounded-pill bg-primary">Scheduled</div></td>
            `;
            }              
            else if (workflow.status === 'PA'){    
            workflow_text += `  
                <td><div class="badge rounded-pill bg-success">Passed</div></td>
            `;
            }
            else if (workflow.status === 'PE'){    
            workflow_text += `      
                <td><div class="badge rounded-pill bg-secondary">Pending</div></td>
            `;
            }    
            
            var commit_id = workflow.git_commit_id
            var trunc_commit_id = commit_id.substring(0,7);
            
            workflow_text += `
    
                <td><a href="https://github.com/${workflow.project.git_permissions.git_organisation}/${workflow.project.git_permissions.git_repo_name}/commit/${ workflow.git_commit_id }">${ trunc_commit_id}</a></td>
        
            `;
            
            
            if (workflow.status != 'SC'){    
                if (workflow.trigger_type === 'IN'){
                    workflow_text += `
                        <td>Initial</td>
                    `;
                }
                else if (workflow.trigger_type === 'PU'){
                    workflow_text += `
                        <td>Push</td>
                    `;
                }
                else if (workflow.trigger_type === 'MA'){    
                    workflow_text += `
                        <td>Manual</td>
                    `;
                }
                else if (workflow.trigger_type === 'CR'){    
                    workflow_text += `
                        <td>Cron</td>
                    `;
                }  
                else {
                    workflow_text += `
                        <td>-</td>
                    `;                
                    
                }
            } else {
                workflow_text += `
                    <td>-</td>
                `;                    
            }
            
            workflow_text += `
            
                <td >${ workflow.last_run }</td>
                <td>${ workflow.human_readable_runtime}</td>
                
                
                <td>
    
                <a  href="#" data-bs-toggle="modal" data-bs-target="#workflow_log_modal${ workflow.workflow_name }">
                  Log 
                </a>
                <div class="modal fade" id="workflow_log_modal${ workflow.workflow_name }" tabindex="-1" role="dialog" aria-labelledby="workflow_log_modalTitle" aria-hidden="true">
                  <div class="modal-dialog modal-dialog-centered" role="document">
                    <div class="modal-content">
                      <div class="modal-header">
                        <h5 class="modal-title" id="workflow_log_modalTitle">Log</h5>
                      </div>
                      <div class="modal-body">
                        
                        <div class="card mb-4">
                        <div class="card-body">               
                        <div class="tab-pane active" id="cardNavPillsHtml" role="tabpanel" aria-labelledby="cardNavPillsHtmlTab">
                            <pre class="  language-markup"><span class="token punctuation"></span>${ workflow.output }</span> </span> </pre>
                        </div>          
                        </div>    
                        </div>    
                      </div>
                      <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
                      </div>
                    </div>
                  </div>
                </div>
                </td>                
                
                <td> 
                    <button  type="button" class="btn" data-workflowid="${ workflow.pk}" data-bs-toggle="modal" data-bs-target="#delete_workflow" data-bs-toggle="tooltip" data-bs-placement="top" title="Delete workflow">
                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-trash-2"><polyline points="3 6 5 6 21 6"></polyline><path d="M19 6v14a2 2 0 0 1-2 2H7a2 2 0 0 1-2-2V6m3 0V4a2 2 0 0 1 2-2h4a2 2 0 0 1 2 2v2"></path><line x1="10" y1="11" x2="10" y2="17"></line><line x1="14" y1="11" x2="14" y2="17"></line></svg>
	                </button>   
                </td>      
                </tr>    
            `;    
        }
        
      });      
    
    branch_text = branch_start + workflow_text + branch_end
    // branch_text = branch_start + branch_end
    
    return branch_text;
    
    }).join('');  
  
    workflowsDiv.innerHTML += branchdata
  
    branches.forEach((branch) => { 
        
        
        
        var branch_name = "#" + branch.name_of_branch
        
        table = new DataTable(branch_name, {
            
            "ordering": false, // can't do the sorting using javascript if we are going to manipulate the displayed names of the workflows, since the sorting is based on the displayed names. Sorting must be done in python
            "searching": false
            //  "order": [[ 0, 'asc' ], [ 4, 'desc' ]] 
            
        });
        
    });

});



function format_runtime(time) {   
    // Hours, minutes and seconds
    var hrs = ~~(time / 3600);
    var mins = ~~((time % 3600) / 60);
    var secs = ~~time % 60;

    // Output like "1:01" or "4:03:59" or "123:03:59"
    var ret = "";
    if (hrs > 0) {
        ret += "" + hrs + ":" + (mins < 10 ? "0" : "");
    }
    ret += "" + mins + ":" + (secs < 10 ? "0" : "");
    ret += "" + secs;
    return ret;
}
