import React from 'react';
import {Row, Col, Button, Card, Modal, Form} from 'react-bootstrap';
import {CloseForm, RefreshForm} from './shared_functions.js'

export class RefreshButton extends React.Component {
  constructor(props) {
    super(props);
    this.handleClose = this.handleClose.bind(this);
    this.state = {
      show: false
    };
  }
  
  handleShow(){
      this.setState({show:true});
  }
 
  handleClose(){
      this.setState({show:false});
  }

    
  render(){

    let button=<div></div>

    if (this.props.size == "large"){
      button = <Button variant="primary btn"    onClick={() => this.handleShow()} >
      Refresh
      </Button>
    } else {
      button = <Button variant="primary btn-sm"    onClick={() => this.handleShow()} >
      <svg width="12" height="12" aria-hidden="true" focusable="false" data-prefix="fas" data-icon="sync" className="svg-inline--fa fa-sync fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M440.65 12.57l4 82.77A247.16 247.16 0 0 0 255.83 8C134.73 8 33.91 94.92 12.29 209.82A12 12 0 0 0 24.09 224h49.05a12 12 0 0 0 11.67-9.26 175.91 175.91 0 0 1 317-56.94l-101.46-4.86a12 12 0 0 0-12.57 12v47.41a12 12 0 0 0 12 12H500a12 12 0 0 0 12-12V12a12 12 0 0 0-12-12h-47.37a12 12 0 0 0-11.98 12.57zM255.83 432a175.61 175.61 0 0 1-146-77.8l101.8 4.87a12 12 0 0 0 12.57-12v-47.4a12 12 0 0 0-12-12H12a12 12 0 0 0-12 12V500a12 12 0 0 0 12 12h47.35a12 12 0 0 0 12-12.6l-4.15-82.57A247.17 247.17 0 0 0 255.83 504c121.11 0 221.93-86.92 243.55-201.82a12 12 0 0 0-11.8-14.18h-49.05a12 12 0 0 0-11.67 9.26A175.86 175.86 0 0 1 255.83 432z"></path></svg>
      </Button>
    }    
    let init_confirmation_screen =     <>

      {button}

      <Modal show={this.state.show} onHide={() => this.handleClose()}>
        <Modal.Header closeButton>
          <Modal.Title>Initialise Pipeline</Modal.Title>
        </Modal.Header>
        <Modal.Body> Would you like to proceed with re-initialising this pipeline?</Modal.Body>
        <Modal.Footer>
        <RefreshForm pipeline_id={this.props.pipeline_id} onHide={this.handleClose}  closeModal={() => this.handleClose()}/> 

        </Modal.Footer>
      </Modal>
    </>;
  return(<React.Fragment>
  {init_confirmation_screen}
  </React.Fragment>);
  }
}  


export class Breadcrumb extends React.Component {
      render(){
        let pageList=this.props.pageList;
        let linkColumns=[];
        for (let i=0; i<pageList.length; i++){
            let arrow= '>';
            if (i==pageList.length-1){
                arrow='';
            }
            linkColumns.push(<React.Fragment key={i}>
                <Col md="auto" >
                <a  href={pageList[i][1]}>{pageList[i][0]}</a>
                </Col>
                <Col md="auto">
                {arrow}

            </Col>
            </React.Fragment>
            );

        }
        return(
            <div>
                <Row>
                {linkColumns}
                </Row>
            </div>
            );
      }
}


export class LogButton extends React.Component {
    constructor(props) {
      super(props);
      this.handleClose = this.handleClose.bind(this);
      this.state = {
        show: false
      };
    }  
    handleShow(){
        this.setState({show:true});
    } 
    handleClose(){
        this.setState({show:false});
    }    
      render(){
        let log_screen =     <>
          <Button variant="primary btn-sm"  onClick={() => this.handleShow()} >
            Log 
          </Button>  
          <Modal dialogClassName="modal-xl" show={this.state.show} onHide={() => this.handleClose()}>
            <Modal.Header closeButton>
              <Modal.Title>Log</Modal.Title>
            </Modal.Header>
            <Modal.Body>
              <div className="card mb-4">
                <Card.Body className="card-body">
                    <pre className="  language-markup">{this.props.output}</pre>
                </Card.Body>
              </div>  
            </Modal.Body>
            <Modal.Footer>
            <CloseForm onHide={this.handleClose}  closeModal={() => this.handleClose()}/>           
            </Modal.Footer>
          </Modal>
        </>;
        return(<div>
        {log_screen}
        </div>);
      }
  }


