import React from 'react';
import ReactDOM from "react-dom";
import styled from "styled-components";

export default class StopWatch extends React.Component {
  constructor(props) {
    // console.log('props' + props.start_time)

    super(props);
    this.state = { seconds: props.start_time };
  }

  tick() {
      if (this.props.status=='RU'){
        
        if ((this.state.seconds + 4) < this.props.start_time){
          // the timer doesn't tick when the window is not active -- the displayed value can fall behind the actual value in the database. And the timer does not correct itself without having to refresh the page
          this.setState(state => ({
            seconds: this.props.start_time
          }));
        } else if ((this.state.seconds + 1) > this.props.start_time){
          // this solves the bug where the run time value from the top row is duplicated when a new row is added to a table (i.e. the displayed run time starts at a non-zero value)
          this.setState(state => ({
            seconds: this.props.start_time
          }));
        } else {
          this.setState(state => ({
            seconds: state.seconds + 1
          }));
        }
      } else {
        this.setState(state => ({
          seconds: this.props.start_time
        }));            
      }
  }
  
  // tick() {
  //     if (this.props.status=='RU'){
  //       this.setState(state => ({
  //         seconds: state.seconds + 1
  //       }));
  //     }
  // }
  
  componentDidMount() {
      this.interval = setInterval(() => this.tick(), 1000);

  }
  componentWillUnmount() {
    clearInterval(this.interval);
  }
  
 render(){
  var seconds = this.state.seconds % 60
  var mins = this.state.seconds/60
  var hours = mins/60
  var days = hours/24
  mins=mins % 60
  hours=hours % 24
  var display_mins = Math.floor(mins)
  var display_hours = Math.floor(hours)
  var display_days = Math.floor(days)
  var styles = {
    marginBottom: '0px',
  };
  var time_display= seconds + 's'
  if (display_mins != 0){
    time_display=display_mins + 'm ' + time_display
  }
  if (display_hours != 0){
    time_display=display_hours + 'h ' + time_display
  }
  if (display_days != 0){
    time_display=display_days + 'd ' + time_display
  }
  if(this.props.status=='PE'){
    time_display='Pending';
  } else if(this.props.status=='QU'){
    time_display='Queued';
  } else if(this.props.status=='ID'){
    time_display='Idle';
  }  
   return(<div className='h5 ' style={styles}>
   {time_display}
   </div>)
 } 
}