const path = require('path');

module.exports = {
    entry: {
        jobview: './assets/router.js',
    },
  output: {
    filename: 'view-router.js',  // output bundle file name
    path: path.resolve(__dirname, './app/automation/static'),  // path to our Django static directory
  },
  module: {
    rules: [
        {
        test: /\.svg$/,
        use: [
          {
            loader: 'svg-url-loader',
            options: {
              limit: 10000,
            },
          },
        ],
      },
     {
        test: /\.(png|jpe?g|gif)$/i,
        use: [
          {
            loader: 'file-loader',
          },
        ],
      },
      {
        test: /\.(js|jsx)$/,
        exclude: /node_modules/,
        loader: "babel-loader",
        options: { presets: ["@babel/preset-env", "@babel/preset-react"] }
      },
      {
        test: /\.css$/i,
        use: [ "css-loader"],
      },
      
    ]
  }
};